
//	Copyright 2010 PaletteSoft LLC

//	*     *   ***   ******* *     *                                           
//	**   **  *   *     *    **    *                                           
//	* * * * *     *    *    * *   *                                           
//	*  *  * *     *    *    *  *  *                                           
//	*     * *******    *    *   * *                                           
//	*     * *     *    *    *    **                                           
//	*     * *     * ******* *     *                                           

// ===========================================================================
// =	CL^										@@@@@@					 =
// ===========================================================================
//	017 2010.10.22
//	ERTCC̏𑗐MŁ[^[Ɋ܂߂ by A.Ohta
// ---------------------------------------------------------------------------
//	016 2010.10.21
//	E{^̒ǉ(tA̐ݒύXj by A.Ohta
// ---------------------------------------------------------------------------
//	015 2010.10.17
//	E{^̒ǉ(݂̂̐ݒύXj by A.Ohta
// ---------------------------------------------------------------------------
//	014 2010.10.16
//	EPIC24FJ64GA002 RTCC ɂtA̕t by A.Ohta
// ---------------------------------------------------------------------------
//	013 2010.10.04
//	EPIC24FJ64GA002 p SHT-11 xZT[Rg[̒ǉ by A.Ohta
// ---------------------------------------------------------------------------
//	012 2010.10.02
//	EPIC24FJ64GA002 ɑΉ̈וύXAxZT[̍폜@by A.Ohta
// ---------------------------------------------------------------------------
//	011 2010.08.24
//	EC\Vtg\ɂi\[`̊Sj@by A.Ohta
// ---------------------------------------------------------------------------
//	010 2010.08.18
//	EI/O_̏C@by A.Ohta
// ---------------------------------------------------------------------------
//	009 2010.08.10
//	Evbg[`̒ǉ@by A.Ohta
// ---------------------------------------------------------------------------
//	008 2010.08.08
//	ESHT-11 C^[tF[XI[vhCɑΉɔ
//   xf[^RS232CʐM̕ύX@by A.Ohta
// ---------------------------------------------------------------------------
//	007 2010.08.07
//	ESHT-11 C^[tF[XI[vhCɑΉ@by A.Ohta
// ---------------------------------------------------------------------------
//	006 2010.07.31
//	EvO̖ʂȂAvOTCYׁ@by A.Ohta
// ---------------------------------------------------------------------------
//	005 2010.07.30
//	EUSARTW[̎gpsׁ@by A.Ohta
// ---------------------------------------------------------------------------
//	004 2010.07.26
//	Ex\ʐM[`̒ǉɂC@by A.Ohta
// ---------------------------------------------------------------------------
//	003 2010.07.26
//	Ex\[`̒ǉɂC@by A.Ohta
// ---------------------------------------------------------------------------
//	002 2010.07.12
//	ECC\[`̏C@by A.Ohta
// ---------------------------------------------------------------------------
//	001 2010.06.28
//	EVK쐬 PaletteSoft LLC@̃vOXg̈ꕔ@OtBbNLCD
//   (mLA5110LCDjbgjɕ\o悤ɈꕔύXĐ@by A.Ohta
// ===========================================================================


#define	SYSTEM_NAME				"SCP1000-D01 SAMPLE PROGRAM"			//	VXe
#define	COPYRIGHT				"Copyright 2010 PaletteSoft LLC"		//	쌠

// ***************************************************************************
// *	CN[ht@C														 *
// ***************************************************************************

	//	*****  *****

#include	"p24FJ64GA002.h"											//  PIC^

#include	<uart.h>

	//	***** 錾 *****

#include	"_AtrDef24f.h"												//	萔Af[^^̐錾

	//	*****  *****

#include	"version.h"													//	o[Wԍ̒`

#include	"device.h"													//	foCX

#include	"press.h"													//	̓ZT

#include	"nokiaGlcdlib.h"											//  LCD

#include	"sht.h"														//  sht

#include	"rtcc.h"													//  RTCC

// ***************************************************************************
// *	Œl																 *
// ***************************************************************************

// bZ[W̒` //

// ***************************************************************************
// *	O[oϐ															 *
// ***************************************************************************

UB		vMngDispBuffer[16];												//	\pobt@

sPres	vMngMeasData;													//	茋
UW		vMngPres;														//	Cf[^
UH		vMngTemp;														//	xf[^
UH		vMngRhum;														//	xf[^		

UH MemPres[48];															//  \pCf[^̋L̈

unsigned char nummsg0[] = "100.0";										//  lϊpobt@100%\p
unsigned char nummsg1[] = "50";											//  lϊpobt@1
unsigned char nummsg2[] = "0";											//  lϊpobt@2
unsigned char nummsg3[] = "0";											//  lϊpobt@2

UINT gint;
UINT gcount;
UINT gintT;
UINT gX;

UINT LCD_MAX_PRES;
UINT LCD_MIN_PRES;

UH	aDValHR;

UB mode;

UB intrtccYearH;													//  BCD year H
UB intrtccYearL;													//  BCD year L
UB intrtccMonthH;													//  BCD month H
UB intrtccMonthL;													//  BCD month L
UB intrtccWeekH;													//  BCD Week H
UB intrtccWeekL;													//  BCD week L
UB intrtccDayH;														//  BCD day H
UB intrtccDayL;														//  BCD day L

UB intrtccHourH;													//  BCD hour H
UB intrtccHourL;													//  BCD hour L
UB intrtccMinH;														//  BCD min H
UB intrtccMinL;														//  BCD min L
UB intrtccSecH;														//  BCD sec H
UB intrtccSecL;														//  BCD sec L

int rtccYearH;															// for BCD Year H
int rtccYearL;															// for BCD Year L
int rtccMonthH;															// for BCD Month H
int rtccMonthL;															// for BCD Month L
int rtccDayH;															// for BCD Day H
int rtccDayL;															// for BCD Day L

int rtccHourH;															// for BCD Hour H
int rtccHourL;															// for BCD Hour L
int rtccMinH;															// for BCD Min H
int rtccMinL;															// for BCD Min L
int rtccSecH;															// for BCD Sec H
int rtccSecL;															// for BCD Sec L

// ***************************************************************************
// *	e[u																 *
// ***************************************************************************

	//	***** VXe *****

const	UB		tSystemName[] = SYSTEM_NAME;							//	VXe̕
const	UB		tCopyright[] = COPYRIGHT;								//	쌠\
const	UB		tVersion[] = {											//	o[Wԍ
					VER1 | '0', VER2 | '0', '.', VER3 | '0', VER4 | '0', CODE_NUL
};

	//	*****  *****

const	UB		tCrLf[] = "\r\n";										//	bqCke

const	UB		tCnvHexAscL[16] = {										//	Srbg̐lPUȋ啶R[hɕϊ
	'0',	'1',	'2',	'3',	'4',	'5',	'6',	'7',
	'8',	'9',	'A',	'B',	'C',	'D',	'E',	'F',
};

// ***************************************************************************
// *	}N錾																 *
// ***************************************************************************


// ***************************************************************************
// *	vg^Cv錾															 *
// ***************************************************************************

	//	***** }lWg *****

void	MngSensorInit(void);

	//	***** \ *****

void	MngDspHello(void);

void	MngDspValue(void);
void	MngDspPress(UW Pres);
void	MngDspTemp(UH Temp);
void	MngDspRhum(UH Rhum);
void	MngDspDateTime(void);
void	MngplotPres(UW);
void	MngplotTemp(UH);
void	MngplotRhum(UH);

void	modecheck(void);
void	datetimeset(void);

	//	***** Cu *****

UB*		LibHexAscUB(UB *Buffer, UB Value);

UH		LibDivUH(UH Value1, UH Value2);
UW		LibMulUH(UH Value1, UH Value2);

void	LibItoA4(UB *Buffer, UH Value);

void itostring(char digit, unsigned int data, char *buffer);

// ***************************************************************************
// *	{																 *
// ***************************************************************************

//	
//	
//
// 		}lWg
//
//	
//	
void	Mng______(void) {}												//	op֐

//============================================================================
//	C
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	X^[gAbv[`̃Wv߂ŌĂяo܂B
//			{֐͖[vłAEo邱Ƃ͂܂B
//============================================================================
int	main(void)
{
	//	***** ͂߂ *****
	int	i;
	mode = 0;															//  init mode.

	intrtccYearH  = 0x1;												//  init BCD year H 1
	intrtccYearL  = 0x0;												//  init BCD year L 0(2010)

	intrtccMonthH = 0x1;												//  init BCD month H 0
	intrtccMonthL = 0x0;												//  init BCD month L 1(01)

	intrtccWeekH  = 0x0;												//  init BCD Week H 0
	intrtccWeekL  = 0x5;												//  init BCD Week L 5(Fri.)

	intrtccDayH   = 0x0;												//  init BCD day H 0
	intrtccDayL   = 0x1;												//  init BCD day L 1(01)

																		//  00:00:00
	intrtccHourH  = 0x0;												//  init BCD hour H 0
	intrtccHourL  = 0x0;												//  init BCD hour L 0(00)

	intrtccMinH   = 0x0;												//  init BCD min H 0
	intrtccMinL   = 0x0;												//  init BCD min L 0(00)

	intrtccSecH   = 0x0;												//  init BCD sec H 0
	intrtccSecL   = 0x0;												//  init BCD sec L 0(00)

	DevInit();															//	foCXݒ
	RtccInit();															//  RTCC
	DevSpiInit();														//	roh䏉ݒ
	SHTInit();															//  SHTݒ
	LCD_init();															// @LCD

	LCD_locate(0,0);
	LCD_clear(LCD_WIDTH * LCD_BANKS);

	print_unithps();
	print_percent();
	print_unitdeg();
	print_Yaxis();
  
	for (i = 0;i<48;i++) {												//  MemPres[]ōlŃNA
		MemPres[i] = 2000;
	}

	gintT = 3599;														//  Initial setting interval time for plott.
	gcount = 3600;

	//	***** ^pJn *****

	MngDspHello();														//	uN\
	MngSensorInit();													//	ZTݒ
	PrsSeqMeas();														//	Jniʂ͖܂cÎ͂j

	//	*****  *****

	while (1) {															//	[vł
		putsUART1((unsigned int *)"SCP,");											//	\

		if (PrsSeqGetData(&vMngMeasData)) {								//	łH	ł܂Ŗ񂵂Ă܂

			//	***** f[^ҏW *****									//				̃f[^Zbg܂łɏĂiTOOj

			readRTCC();													//  RTCCtƎǂݏo
			MngDspDateTime();											//  \

			MngDspValue();												//	茋ʂPUiŕ\

			vMngPres = PrsCalGetPres(&vMngMeasData);					//	Cf[^擾
			vMngTemp = PrsCalGetTemp(&vMngMeasData);					//	xf[^擾
			vMngRhum = ShtCalGetRhum();									//	xf[^擾

			MngDspPress(vMngPres);										//	Cf[^̕ʕ\
			MngDspTemp(vMngTemp);										//	xf[^̕ʕ\
			MngDspRhum(vMngRhum);										//  xf[^̕ʕ\

			if (gcount>gintT){											//  gintTC^[oPlot
				MngplotPres(vMngPres);									//  CplotB
				MngplotTemp(vMngTemp);									//  CplotB
				MngplotRhum(vMngRhum);									//  xplotB

				if (gX<48){												//  vbgʒu+PBgX:0`47
					gX++;
				}
				else{													//  vbgʒuE[܂œBꍇ́A[㏑B
					gX = 0;
				}
				gcount = 0;
			}
			else{
					gcount++;
			}
		}
		else {															//	莸s

			//	***** 莸s *****

			putsUART1((unsigned int *)" RTERR ");						//	A^CG[\
		}

		modecheck();

	}
}

//============================================================================
//	ZTݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	ZT̋Nҋ@܂BNɈُ킪oꂽꍇ̓ZT
//			Zbgs܂BN܂ł̍ƂJԂ܂B
//============================================================================
void	MngSensorInit(void)
{
	UB		Result;														//	

	//	***** ݒ菄 *****

	while (1) {															//	N܂ŌJԂ܂B

		//	***** ݒ *****

		putsUART1((unsigned int *)"SENSOR INIT ");						//	\

		Result = PrsSeqInit();											//	ZT̏ݒ
		putsUART1((unsigned int *)LibHexAscUB(vMngDispBuffer, Result));	//	ʂPUiɕϊĕ\
		putsUART1((unsigned int *)" ");

		//	***** ݒ茋ʐff *****

		if ((Result & PRS_INIT_RESULT_MASK) != PRS_INIT_RESULT_OK) {	//	ݒ莸sH
			putsUART1((unsigned int *)"NG \r\n");						//	\
			delay_ms(250);												//	QTOҋ@
			delay_ms(250);												//	QTOҋ@
		}
		else {															//	ݒ萬
			break;														//	Eo
		}
	}

	//	***** ݒI *****

	Result = PrsSeqGetRevid();											//	rWԍ擾

	putsUART1((unsigned int *)"OK, ASIC:");								//	\
	putsUART1((unsigned int *)LibHexAscUB(vMngDispBuffer, Result));		//	ʂPUiɕϊĕ\
	putsUART1((unsigned int *)tCrLf);									//	bqAke
}

//	
//	
//
// 		\
//
//	
//	
void	MngDsp______(void) {}											//	op֐

//============================================================================
//	uN\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	uNƂ𒲕VAʐMŒʒm܂B
//============================================================================
void	MngDspHello(void)
{
	//	***** o *****

	putsUART1((unsigned int *)tCrLf);									//	bqAke
	putsUART1((unsigned int *)tCrLf);									//	bqAke

	//	***** ^Cg *****

	putsUART1((unsigned int *)tSystemName);								//	VXe

	putsUART1((unsigned int *)"  Ver");									//	o
	putsUART1((unsigned int *)tVersion);								//	o[Wԍ
	putsUART1((unsigned int *)tCrLf);									//	bqAke

	putsUART1((unsigned int *)tCopyright);								//	쐬
	putsUART1((unsigned int *)tCrLf);									//	bqAke

	//	***** ܂ *****

	putsUART1((unsigned int *)tCrLf);									//	bqAke
}

//============================================================================
//	茋ʂPUiŕ\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	ς݂̃f[^PUiŕ\܂B
//
//			ss,tttt,mm,llll,ss,
//============================================================================
void	MngDspValue(void)
{
	//	***** Xe[^XP *****

	putsUART1((unsigned int *)LibHexAscUB(vMngDispBuffer, vMngMeasData.Status1));
	putsUART1((unsigned int *)",");

	//	***** xf[^ *****

	putsUART1((unsigned int *)LibHexAscUB(vMngDispBuffer, vMngMeasData.Temp     >> 8));
	putsUART1((unsigned int *)LibHexAscUB(vMngDispBuffer, vMngMeasData.Temp         ));
	putsUART1((unsigned int *)",");

	//	***** Cf[^ilraj *****

	putsUART1((unsigned int *)LibHexAscUB(vMngDispBuffer, vMngMeasData.PresMsb));
	putsUART1((unsigned int *)",");

	//	***** Cf[^ikraj *****

	putsUART1((unsigned int *)LibHexAscUB(vMngDispBuffer, vMngMeasData.PresLsb >> 8));
	putsUART1((unsigned int *)LibHexAscUB(vMngDispBuffer, vMngMeasData.PresLsb     ));
	putsUART1((unsigned int *)",");

	//	***** Xe[^XQ *****

	putsUART1((unsigned int *)LibHexAscUB(vMngDispBuffer, vMngMeasData.Status2));
	putsUART1((unsigned int *)",");

	//	***** ܂ *****

	putsUART1((unsigned int *)" ");
}

//============================================================================
//	Cf[^̕ʕ\							ӁF͈̓`FbN͎蔲
//----------------------------------------------------------------------------
//	́F	Cf[^
//	óF	
//----------------------------------------------------------------------------
//	lF	Cf[^𕨗ʕϊĕ\܂B
//
//			f[^\F0.25Pa/bit
//			f[^͈́F30000.00 - 120000.00Pa		QlF100Pa = 1hPa
//			\`@FP:XXXXhPa,
//============================================================================
void	MngDspPress(UW Pres)
{
	UH		Value;														//	Ɨpϐ

/*
	Cf[^pXJϊ
		Pa = Pres * 0.25 = Pres / 4
	ƂȂ܂BZ͉ł܂_ȉ͐؂̂ĂɂȂ܂B
	āApXJwNgpXJɕϊꍇ́A
		100Pa = 1hPa
	A_ȉ̐؂̂ĂƁA
		hPa = (Pres / 4) / 100 = Pres / (4 * 100) = Pres / 400
	ƂȂ܂B
*/
	Value = (UH)(Pres / 400L);											//	ʏ300 `1200͈͓̔̂͂

	LibItoA4(vMngDispBuffer, Value);									//	l𕶎ɕϊisSj

	if (vMngDispBuffer[0] == '0') {	vMngDispBuffer[0] = ' ';	}		//	[TvXïʂjj

	//	***** pXJ\ *****

	putsUART1((unsigned int *)"P:");									//	
	putsUART1((unsigned int *)vMngDispBuffer);							//	Zʕ\
	putsUART1((unsigned int *)"hPa,");									//	P

	print_press((int)Value);
}

//============================================================================
//	xf[^̕ʕ\							ӁF͈̓`FbN͎蔲
//----------------------------------------------------------------------------
//	́F	xf[^iPSrbg\A}CiXx͂Q̕␔\j
//	óF	
//----------------------------------------------------------------------------
//	lF	xf[^𕨗ʕϊĕ\܂B
//
//			f[^\F0.05c/bit
//			\`@FT:-XX.Xc,
//============================================================================
void	MngDspTemp(UH Temp)
{
/*
	xf[^
		c = Temp * 0.05 = Temp / 20
	ƂȂ܂BZ͉ł܂_ȉ͐؂̂ĂɂȂ܂B
	ɏ_ȉPʂ܂ŋ߂̂ł΁A
		c * 10 = (Temp * 10) / 20 = Temp / 2
	ƂȂ܂B
	Oq̋CƓlALȉ͐؂̂Ăs܂B
	Ȃxɂ̓}CiXl݂܂A؂̂ă[͐ΒlōsĂ܂B
*/

	if (Temp & (UH)BIT15) {												//	}CiXwH
		vMngDispBuffer[0] = '-';										//	vX}[N
		Temp = (~Temp) + 1;												//	ΒlZo
	}
	else {																//	vXw
		vMngDispBuffer[0] = '+';										//	vX}[N
	}

	LibItoA4(&vMngDispBuffer[1], Temp >> 1);							//	l𕶎ɕϊisSj
																		//	ZT\-30c`+85cȂ̂ŁAΒl0`850͈͓̔̂͂
//	12345		12345
//	 XXX*	@XX.X*

	vMngDispBuffer[1] = vMngDispBuffer[2];								//	PÖʂOɈړ
	vMngDispBuffer[2] = vMngDispBuffer[3];								//	P̈ʂOɈړ
	vMngDispBuffer[3] = '.';											//	_

	if (vMngDispBuffer[1] == '0') {	vMngDispBuffer[1] = ' ';	}		//	[TvXi\̈ʂj

	//	***** x\ *****

	putsUART1((unsigned int *)"T:");									//	
	putsUART1((unsigned int *)vMngDispBuffer);							//	Zʕ\
	putsUART1((unsigned int *)"c,");									//	P

	print_temp(Temp/2, (Temp & (UH)BIT15));
}

//============================================================================
//	xf[^̕ʕ\							
//----------------------------------------------------------------------------
//	́Fxf[^i@j
//	óF	
//----------------------------------------------------------------------------
//	lFxf[^𕨗ʕϊĕ\܂B
//
//			f[^\F?/bit
//			\`@FRH:XX.X%,
//============================================================================
void	MngDspRhum(UH Rhum)
{
	int vRhum;
	aDValHR = Rhum;
	vRhum = CalcHR10();

	print_RH(vRhum);

			//	***** xM *****
	putsUART1((unsigned int *)"RH:");									//	
	if(vRhum >= 1000 ){
		putsUART1((unsigned int *)"100.0%,");							//	100.0%\
	}
	else if(vRhum < 100 ){
		itostring(1,vRhum/10, (char *)nummsg2);
		itostring(1,vRhum%10, (char *)nummsg3);

		putsUART1((unsigned int *)&nummsg2);							//	Zʕ\
		putsUART1((unsigned int *)".");									//	Pʏ_
		putsUART1((unsigned int *)&nummsg3);							//	Zʕ\
		putsUART1((unsigned int *)"%,");								//	P
	}
	else {

		itostring(2,vRhum/10, (char *)nummsg1);
		itostring(1,vRhum%10, (char *)nummsg2);

		putsUART1((unsigned int *)&nummsg1);							//	Zʕ\
		putsUART1((unsigned int *)".");									//	Pʏ_
		putsUART1((unsigned int *)&nummsg2);							//	Zʕ\
		putsUART1((unsigned int *)"%");									//	P
	}

	putsUART1((unsigned int *)tCrLf);									//	bqAke
}

//============================================================================
//	xf[^̕ʕ\							
//----------------------------------------------------------------------------
//	́Fxf[^i@j
//	óF	
//----------------------------------------------------------------------------
//	lFxf[^𕨗ʕϊĕ\܂B
//
//			f[^\F?/bit
//			\`@FRH:XX.X%,
//============================================================================
void	MngDspDateTime(void)
{

	char MsgDate[] = "20xx/xx/xx,";										//  for Date Stamp
	char MsgTime[] = "xx:xx:xx, ";										//  for Time Stamp

	MsgDate[2] = rtccYearH + 0x30;										// N
	MsgDate[3] = rtccYearL + 0x30;
	MsgDate[5] = rtccMonthH + 0x30;										// 
	MsgDate[6] = rtccMonthL + 0x30;
	MsgDate[8] = rtccDayH + 0x30;										// 
	MsgDate[9] = rtccDayL + 0x30;
	MsgTime[0] = rtccHourH + 0x30;										// 
	MsgTime[1] = rtccHourL + 0x30;
	MsgTime[3] = rtccMinH + 0x30;										// 
	MsgTime[4] = rtccMinL + 0x30;
	MsgTime[6] = rtccSecH + 0x30;										// b
	MsgTime[7] = rtccSecL + 0x30;

	putsUART1((unsigned int *)&MsgDate);								//	send Date
	putsUART1((unsigned int *)&MsgTime);								//	send Time

	print_rtccdate();													//  t\
	print_rtcctime();													//  \

}

//============================================================================
//	Cf[^Plot							
//----------------------------------------------------------------------------
//	́F	Cf[^
//	óF	
//----------------------------------------------------------------------------
//	lF
//
//============================================================================
void	MngplotPres(UW Pres)
{
	int i;
	UH	Value;
	Value = (UH)(Pres / 400L);											//	ʏ300 `1200͈͓̔̂͂
	MemPres[gX] = Value;												//  Cf[^̗cB
 
	if (Value > LCD_MAX_PRES ) {										//  \̍ől𒴂H
		LCD_MAX_PRES = Value;											//  ݂̒lőƂ臒lɕύXB
		LCD_MIN_PRES = LCD_MAX_PRES - 15 ;
		for (i = 0; i < 48 ; i++ ) {
			print_Presgraph(i, MemPres[i] );							//  C̗V臒lŃvbg
		}
	}
	else if (Value < LCD_MIN_PRES ) {									//  \̍ŏlH
		LCD_MIN_PRES = Value;											//  ݂̒lŏƂ臒lɕύXB
		LCD_MAX_PRES = LCD_MIN_PRES + 15 ;
		for (i = 0; i < 48 ; i++ ) {
			print_Presgraph(i, MemPres[i] );							//  C̗V臒lŃvbg
		}
	}
	print_Presgraph(gX, Value);											//  ݂̋Cvbg
}

//============================================================================
//	Cf[^Plot							
//----------------------------------------------------------------------------
//	́F	Cf[^
//	óF	
//----------------------------------------------------------------------------
//	lF
//
//============================================================================
void	MngplotTemp(UH Temp)
{
	if (Temp & (UH)BIT15) {												//	}CiXwH
		Temp = (~Temp) + 1;												//	ΒlZo
	}
	print_Tempgraph(gX, (int)Temp/20);									//  Cvbg																	
}

//============================================================================
//	xf[^Plot							
//----------------------------------------------------------------------------
//	́F	xf[^
//	óF	
//----------------------------------------------------------------------------
//	lF
//
//============================================================================
void	MngplotRhum(UH Rhum)
{
	int vRhum;

	aDValHR = Rhum;
	vRhum = CalcHR10();													//  xf[^𕨗ʂɕϊB

	print_Rhumgraph(gX, vRhum/10);										//  xvbg																	
}

//	
//	
//
// 		Cu
//
//	
//	
void	Lib______(void){}												//	op֐

//============================================================================
//	PoCglPUiɕϊ
//----------------------------------------------------------------------------
//	́F	i[obt@iQ{PjAlA
//	óF	i[obt@
//----------------------------------------------------------------------------
//	lF	PoCglQ̂PUiɕϊ܂B
//============================================================================
UB*	LibHexAscUB(UB *Buffer, UB Value)
{
	Buffer[0] = tCnvHexAscL[Value >> 4];								//	ʂSrbgϊ
	Buffer[1] = tCnvHexAscL[Value & 0x0f];								//	ʂSrbgϊ
	Buffer[2] = CODE_NUL;												//	I[R[hZbg

	return(Buffer);														//	obt@AhXԂ܂
}

//============================================================================
//	QoCgQoCgQoCg
//----------------------------------------------------------------------------
//	́F	񏜐A
//	óF	
//----------------------------------------------------------------------------
//	lF	QoCg̏Zs܂B
//============================================================================
UH		LibDivUH(UH Value1, UH Value2)
{
	return(Value1 / Value2);											//	QoCgZʂԂ܂
}


//============================================================================
//	QoCg~QoCgSoCg
//----------------------------------------------------------------------------
//	́F	搔A搔
//	óF	
//----------------------------------------------------------------------------
//	lF	QoCg̏Zs܂B
//============================================================================
UW		LibMulUH(UH Value1, UH Value2)
{
	return((UW)Value1 * (UW)Value2);									//	QoCg̏ZʂԂ܂
}

//============================================================================
//	͋ẐSPOiϊ
//----------------------------------------------------------------------------
//	́F	i[AhXAl
//	óF	
//----------------------------------------------------------------------------
//	lF	QoCgl𕶎ɕϊ܂BL͂S܂łłB
//============================================================================
void	LibItoA4(UB *Buffer, UH Value)
{
	UB		Digit;														//	P̐l

	Digit = (UB)LibDivUH(Value,      1000);								//	@POOÖʕҏW
	Value -= (UH)LibMulUH((UH)Digit, 1000);
	Buffer[0] = Digit + '0';

	Digit = (UB)LibDivUH(Value,       100);								//	@@POÖʕҏW
	Value -= (UH)LibMulUH((UH)Digit,  100);
	Buffer[1] = Digit + '0';

	Digit = (UB)LibDivUH(Value,        10);								//	@@@PÖʕҏW
	Value -= (UH)LibMulUH((UH)Digit,   10);
	Buffer[2] = Digit + '0';

	Buffer[3] = (UB)Value + '0';										//	@@@@P̈ʕҏW

	Buffer[4] = CODE_NUL;												//	I[Zbg
}

//============================================================================
//	ASCIIɕϊ
//----------------------------------------------------------------------------
//	́F	char digit, unsigned int data, char *buffer
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void itostring(char digit, unsigned int data, char *buffer)
{
	char i;
	buffer += digit;													// Ō̐ʒu
	for(i=digit; i>0; i--) {											// ϊ͉ʂʂ
		buffer--;														// |C^[P
		*buffer = (data % 10) + '0';									// ASCII
		data = data / 10;												// ̌
	}
}

//============================================================================
//	mode ύX Date & Time {^ŕύX
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void modecheck(void)
{
	if(PORTAbits.RA2 == 0){											//  into a setting mode
		mode++;														//  mode change
		print_setting();
		while(PORTAbits.RA2 == 0);									//  waiting release from sw1
		delay_ms(10);
		LCD_locate(0,2);											//  print init data for Day
		LCD_clear(34);

		while(mode != 0){											//  if mode is not 0 then loop
			readRTCC();												//  RTCCtƎǂݏo
			print_rtccdate();										//  t\
			print_rtcctime();										//  \

			LCD_locate(12,2);										//  print init data for Day
			LCD_clear(6 * 2);

			if(PORTAbits.RA2 == 0){
				mode++;												//  mode change
				while(PORTAbits.RA2 == 0);							//  waiting release from sw1
					delay_ms(10);
			}

			if( mode > 12 ){
				mode = 0;
			}

			if( mode == 1 ){
				print_Y();
				print_num(intrtccYearH,2,2);
				print_num(intrtccYearL,3,2);
			}

			if( mode == 2 ){
				print_Question();
				print_num(intrtccYearH,2,2);
				print_num(intrtccYearL,3,2);
			}

			if( mode == 3 ){
				print_M();
				print_num(intrtccMonthH,2,2);
				print_num(intrtccMonthL,3,2);
			}

			if( mode == 4 ){
				print_Question();
				print_num(intrtccMonthH,2,2);
				print_num(intrtccMonthL,3,2);
			}

			if( mode == 5 ){
				print_D();
				print_num(intrtccDayH,2,2);
				print_num(intrtccDayL,3,2);
			}

			if( mode == 6 ){
				print_Question();
				print_num(intrtccDayH,2,2);
				print_num(intrtccDayL,3,2);
			}

			if( mode == 7 ){
				print_H();
				print_num(intrtccHourH,2,2);
				print_num(intrtccHourL,3,2);
			}

			if( mode == 8 ){
				print_Question();
				print_num(intrtccHourH,2,2);
				print_num(intrtccHourL,3,2);
			}

			if( mode == 9 ){
				print_M();
				print_num(intrtccMinH,2,2);
				print_num(intrtccMinL,3,2);
			}

			if( mode == 10 ){
				print_Question();
				print_num(intrtccMinH,2,2);
				print_num(intrtccMinL,3,2);
			}

			if( mode == 11 ){
				print_S();
				print_num(intrtccSecH,2,2);
				print_num(intrtccSecL,3,2);
			}

			if( mode == 12 ){
				print_Question();
				print_num(intrtccSecH,2,2);
				print_num(intrtccSecL,3,2);
			}

			if( mode == 1 ){
				if(PORTBbits.RB0 == 0){
					intrtccYearH++;
					if( intrtccYearH > 9 ){
						intrtccYearH = 0;
					}
					LCD_locate(12,2);
					LCD_clear(6);
					print_num(intrtccYearH,2,2);
					while(PORTBbits.RB0 == 0);
					delay_ms(10);
				}
			}

			if( mode == 1 ){
				if(PORTBbits.RB1 == 0){
					intrtccYearL++;
					if( intrtccYearL > 9 ){
						intrtccYearL = 0;
					}
					LCD_locate(18,2);
					LCD_clear(6);
					print_num(intrtccYearL,3,2);
					while(PORTBbits.RB1 == 0);
					delay_ms(10);
				}
			}

			if( mode == 3 ){
				if(PORTBbits.RB0 == 0){
					intrtccMonthH++;
					if( intrtccMonthH > 1 ){
						intrtccMonthH = 0;
					}
					LCD_locate(12,2);
					LCD_clear(6);
					print_num(intrtccMonthH,2,2);
					while(PORTBbits.RB0 == 0);
					delay_ms(10);
				}
			}

			if( mode == 3 ){
				if(PORTBbits.RB1 == 0){
					intrtccMonthL++;
					if( intrtccMonthH == 0 ){
						if( intrtccMonthL > 9 ){
							intrtccMonthL = 1;
						}
					}
					else{
						if( intrtccMonthL > 2 ){
							intrtccMonthL = 0;
						}
					}
					LCD_locate(18,2);
					LCD_clear(6);
					print_num(intrtccMonthL,3,2);
					while(PORTBbits.RB1 == 0);
					delay_ms(10);
				}
			}

			if( mode == 5 ){
				if(PORTBbits.RB0 == 0){
					intrtccDayH++;
					if( intrtccDayH > 3 ){
						intrtccDayH = 0;
					}
					LCD_locate(12,2);
					LCD_clear(6);
					print_num(intrtccDayH,2,2);
					while(PORTBbits.RB0 == 0);
					delay_ms(10);
				}
			}

			if( mode == 5 ){
				if(PORTBbits.RB1 == 0){
					intrtccDayL++;
					if( intrtccDayL > 9 ){
						if( intrtccDayH != 0 ){
							intrtccDayL = 0;
						}
						else{
							intrtccDayL = 1;
						}
					}
					LCD_locate(18,2);
					LCD_clear(6);
					print_num(intrtccDayL,3,2);
					while(PORTBbits.RB1 == 0);
					delay_ms(10);
				}
			}

			if( mode == 7 ){
				if(PORTBbits.RB0 == 0){
					intrtccHourH++;
					if( intrtccHourH > 2 ){
						intrtccHourH = 0;
					}
					LCD_locate(12,2);
					LCD_clear(6);
					print_num(intrtccHourH,2,2);
					while(PORTBbits.RB0 == 0);
					delay_ms(10);
				}
			}

			if( mode == 7 ){
				if(PORTBbits.RB1 == 0){
					intrtccHourL++;
					if( intrtccHourL > 9 ){
						intrtccHourL = 0;
					}
					LCD_locate(18,2);
					LCD_clear(6);
					print_num(intrtccHourL,3,2);
					while(PORTBbits.RB1 == 0);
					delay_ms(10);
				}
			}

			if( mode == 9 ){
				if(PORTBbits.RB0 == 0){
					intrtccMinH++;
					if( intrtccMinH > 6 ){
						intrtccMinH = 0;
					}
					LCD_locate(12,2);
					LCD_clear(6);
					print_num(intrtccMinH,2,2);
					while(PORTBbits.RB0 == 0);
					delay_ms(10);
				}
			}

			if( mode == 9 ){
				if(PORTBbits.RB1 == 0){
					intrtccMinL++;
					if( intrtccMinL > 9 ){
						intrtccMinL = 0;
					}
					LCD_locate(18,2);
					LCD_clear(6);
					print_num(intrtccMinL,3,2);
					while(PORTBbits.RB1 == 0);
					delay_ms(10);
				}
			}

			if( mode == 11 ){
				if(PORTBbits.RB0 == 0){
					intrtccSecH++;
					if( intrtccSecH > 6 ){
						intrtccSecH = 0;
					}
					LCD_locate(12,2);
					LCD_clear(6);
					print_num(intrtccSecH,2,2);
					while(PORTBbits.RB0 == 0);
					delay_ms(10);
				}
			}

			if( mode == 11 ){
				if(PORTBbits.RB1 == 0){
					intrtccSecL++;
					if( intrtccSecL > 9 ){
						intrtccSecL = 0;
					}
					LCD_locate(18,2);
					LCD_clear(6);
					print_num(intrtccSecL,3,2);
					while(PORTBbits.RB1 == 0);
					delay_ms(10);
				}
			}

			if( mode == 2 || mode == 4 || mode == 6 || mode == 8 || mode == 10 || mode ==12 ){
				if(PORTBbits.RB1 == 0){
					datetimeset();

					readRTCC();										//  RTCCtƎǂݏo
					print_rtccdate();								//  t\
					print_rtcctime();								//  \

					while(PORTBbits.RB1 == 0);
					delay_ms(10);
				}
			}

			delay_ms(5);
		}
		LCD_locate(0,2);
		LCD_clear(6 * 4);
	}
}

//============================================================================
//	rtcc  Date & Time ύX
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void datetimeset(void)
{
	lockfree();														// RTCCݒV[PX

	RCFGCALbits.RTCPTR = 3;											// RTCC access(Write)
	RTCVAL = ((intrtccYearH << 4) | intrtccYearL);					// y = 2010
	RTCVAL = ((intrtccMonthH << 12 ) | (intrtccMonthL << 8 ) | (intrtccDayH << 4) | intrtccDayL);			// month,day
	RTCVAL = ((intrtccHourH << 4 ) | intrtccHourL ) & 0x00FF;												// (week),hour
	RTCVAL = ((intrtccMinH << 12 ) | (intrtccMinL << 8 ) | (intrtccSecH << 4) | intrtccSecL);				// min,sec.
	RCFGCALbits.RTCWREN = 0;										// RTCCݒIbN

	readRTCC();														//  RTCCtƎǂݏo
	print_rtccdate();												//  t\
	print_rtcctime();												//  \
}


// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

